diff --git a/drivers/md/md-bitmap.c b/drivers/md/md-bitmap.c
index 9692acb8cb04..d4164f096d0c 100644
--- a/drivers/md/md-bitmap.c
+++ b/drivers/md/md-bitmap.c
@@ -2105,7 +2105,7 @@ void md_bitmap_set_pages(struct bitmap *bitmap, unsigned long pages)
 }
 EXPORT_SYMBOL_GPL(md_bitmap_set_pages);
 
-int md_bitmap_get_stats(struct bitmap *bitmap, struct md_bitmap_stats *stats)
+static int bitmap_get_stats(struct bitmap *bitmap, struct md_bitmap_stats *stats)
 {
 	bitmap_super_t *sb;
 	struct bitmap_counts *counts;
@@ -2128,7 +2128,6 @@ int md_bitmap_get_stats(struct bitmap *bitmap, struct md_bitmap_stats *stats)
 	stats->behind_wait = wq_has_sleeper(&bitmap->behind_wait);
 	return 0;
 }
-EXPORT_SYMBOL_GPL(md_bitmap_get_stats);
 
 int md_bitmap_resize(struct bitmap *bitmap, sector_t blocks,
 		  int chunksize, int init)
@@ -2720,6 +2719,7 @@ static struct bitmap_operations bitmap_ops = {
 	.flush			= bitmap_flush,
 
 	.update_sb		= bitmap_update_sb,
+	.get_stats		= bitmap_get_stats,
 };
 
 void mddev_set_bitmap_ops(struct mddev *mddev)
diff --git a/drivers/md/md-bitmap.h b/drivers/md/md-bitmap.h
index b2d4e71a478a..5dc61df1aa40 100644
--- a/drivers/md/md-bitmap.h
+++ b/drivers/md/md-bitmap.h
@@ -252,6 +252,7 @@ struct bitmap_operations {
 	void (*flush)(struct mddev *mddev);
 
 	void (*update_sb)(struct bitmap *bitmap);
+	int (*get_stats)(struct bitmap *bitmap, struct md_bitmap_stats *stats);
 };
 
 /* the bitmap API */
@@ -259,8 +260,6 @@ void mddev_set_bitmap_ops(struct mddev *mddev);
 
 /* these are used only by md/bitmap */
 
-int md_bitmap_get_stats(struct bitmap *bitmap, struct md_bitmap_stats *stats);
-
 int  md_bitmap_setallbits(struct bitmap *bitmap);
 void md_bitmap_write_all(struct bitmap *bitmap);
 
@@ -295,7 +294,7 @@ void md_bitmap_wait_behind_writes(struct mddev *mddev);
 static inline u64 md_bitmap_events_cleared(struct mddev *mddev)
 {
 	struct md_bitmap_stats stats;
-	int err = md_bitmap_get_stats(mddev->bitmap, &stats);
+	int err = mddev->bitmap_ops->get_stats(mddev->bitmap, &stats);
 
 	if (err)
 		return 0;
diff --git a/drivers/md/md-cluster.c b/drivers/md/md-cluster.c
index 77111968e276..31108832dd9b 100644
--- a/drivers/md/md-cluster.c
+++ b/drivers/md/md-cluster.c
@@ -1150,7 +1150,7 @@ static int resize_bitmaps(struct mddev *mddev, sector_t newsize, sector_t oldsiz
 	char str[64];
 	int i, rv;
 
-	rv = md_bitmap_get_stats(bitmap, &stats);
+	rv = mddev->bitmap_ops->get_stats(bitmap, &stats);
 	if (rv)
 		return rv;
 
@@ -1174,7 +1174,7 @@ static int resize_bitmaps(struct mddev *mddev, sector_t newsize, sector_t oldsiz
 			goto out;
 		}
 
-		rv = md_bitmap_get_stats(bitmap, &stats);
+		rv = mddev->bitmap_ops->get_stats(bitmap, &stats);
 		if (rv)
 			goto out;
 		/*
@@ -1223,7 +1223,7 @@ static int cluster_check_sync_size(struct mddev *mddev)
 	struct dlm_lock_resource *bm_lockres;
 	struct md_bitmap_stats stats;
 
-	rv = md_bitmap_get_stats(bitmap, &stats);
+	rv = mddev->bitmap_ops->get_stats(bitmap, &stats);
 	if (rv)
 		return rv;
 
@@ -1256,7 +1256,7 @@ static int cluster_check_sync_size(struct mddev *mddev)
 			mddev->bitmap_ops->update_sb(bitmap);
 		lockres_free(bm_lockres);
 
-		rv = md_bitmap_get_stats(bitmap, &stats);
+		rv = mddev->bitmap_ops->get_stats(bitmap, &stats);
 		if (rv) {
 			md_bitmap_free(bitmap);
 			return rv;
diff --git a/drivers/md/md.c b/drivers/md/md.c
index ecfe957279e5..29dd6bc86f3f 100644
--- a/drivers/md/md.c
+++ b/drivers/md/md.c
@@ -2345,7 +2345,7 @@ super_1_allow_new_offset(struct md_rdev *rdev,
 	if (rdev->sb_start + (32+4)*2 > new_offset)
 		return 0;
 
-	err = md_bitmap_get_stats(bitmap, &stats);
+	err = rdev->mddev->bitmap_ops->get_stats(bitmap, &stats);
 	if (!err && !rdev->mddev->bitmap_info.file &&
 	    rdev->sb_start + rdev->mddev->bitmap_info.offset +
 	    stats.file_pages * (PAGE_SIZE>>9) > new_offset)
@@ -7575,7 +7575,7 @@ static int update_array_info(struct mddev *mddev, mdu_array_info_t *info)
 		} else {
 			struct md_bitmap_stats stats;
 
-			rv = md_bitmap_get_stats(mddev->bitmap, &stats);
+			rv = mddev->bitmap_ops->get_stats(mddev->bitmap, &stats);
 			if (rv)
 				goto err;
 
@@ -8372,7 +8372,7 @@ static void md_bitmap_status(struct seq_file *seq, struct mddev *mddev)
 {
 	struct md_bitmap_stats stats;
 	unsigned long chunk_kb;
-	int err = md_bitmap_get_stats(mddev->bitmap, &stats);
+	int err = mddev->bitmap_ops->get_stats(mddev->bitmap, &stats);
 
 	if (err)
 		return;
diff --git a/drivers/md/raid1.c b/drivers/md/raid1.c
index bfd2d63d1c59..5e1a487bd4de 100644
--- a/drivers/md/raid1.c
+++ b/drivers/md/raid1.c
@@ -1604,7 +1604,7 @@ static void raid1_write_request(struct mddev *mddev, struct bio *bio,
 
 		if (first_clone) {
 			struct md_bitmap_stats stats;
-			int err = md_bitmap_get_stats(bitmap, &stats);
+			int err = mddev->bitmap_ops->get_stats(bitmap, &stats);
 
 			/* do behind I/O ?
 			 * Not if there are too many, or cannot